export class DrawPile {
  readonly #draws: {depth: number, op: () => void}[]

  constructor() {
    this.#draws = []
  }

  add(depth: number, op: () => void) {
    this.#draws.push({depth, op});
  }

  execute() {
    let draws = [...this.#draws];
    draws.sort(
      (d0, d1) => d0.depth - d1.depth
    );
    for (let d of draws.values()) {
      d.op();
    }
  }
}